﻿Imports System
Imports System.IO
Imports System.Threading
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.InteropServices
Imports System.Windows.Forms
Imports System.Threading.Tasks
Imports System.Collections
Imports System.Text


'PCR-Program Clock Reference
'PTS-Presentation Time Stamp
'DTS
Public Class Form1
    Delegate Sub WriteButton5TextDelegate(ByVal Value As String)
    Private WriteButton5TextInstance As New WriteButton5TextDelegate(AddressOf WriteButton5Text)
    Delegate Sub WriteDataGridView2Delegate(ByVal i As Int32, ByVal Value As String)
    Private WriteDataGridView2Instance As New WriteDataGridView2Delegate(AddressOf WriteDataGridView2)
    Delegate Sub ForeColorDataGridView2Delegate(ByVal c As Int32, ByVal d As Int32, ByVal Value As System.Drawing.Color)
    Private ForeColorDataGridView2Instance As New ForeColorDataGridView2Delegate(AddressOf ForeColorDataGridView2)

    Delegate Sub WriteListBoxDelegate(ByVal Value As Int32)
    Private WriteListBox1Instance As New WriteListBoxDelegate(AddressOf WriteListBox1)
    Delegate Sub WriteListBoxErrorDelegate(ByVal Value As Int32)
    Private WriteListBox1ErrorInstance As New WriteListBoxErrorDelegate(AddressOf WriteListBox1Error)

    'PTSとPCRの同期 PTSが先にくる PCRはPTSより小さい
    'PTSをAM01:00:00からにPTS=324000000
    'Private Const startGOPPTS As Long = 324000000L
    'PCR をAM1:00:00からにPCR=324000000L * 300
    'Private startPCR As Long = 324000000L * 300
    Private Const DataGriedViewColum0Width = 362
    Private Const DataGriedViewColum1Width = 112
    Private Const DataGriedViewColum2Width = 82
    Private Const DataGriedViewColum3Width = 82
    Private Const DataGriedViewScrollBWidth = 20

    Private _sorder As Int32 = 0
    Private bIsExecute As Boolean

    'フォルダ選択
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim srcPath2 As String = SelectFolder(Me, srcPath)
        If String.IsNullOrEmpty(srcPath2) Then Exit Sub
        Dim files As String() = System.IO.Directory.GetFiles(srcPath2, "*.ts", System.IO.SearchOption.TopDirectoryOnly)
        'DataGridView1ファイル名追加
        'DataGridView2ファイル名追加
        Me.DataGridView1.Rows.Clear()
        Me.DataGridView2.Rows.Clear()
        Dim fileI As String
        Dim i As Int32 = 0
        For Each fileI In files
            If Path.GetExtension(fileI).ToLower = ".ts" Then
                setFilesToDataGridView(i, fileI)
                i += 1
            End If
        Next
        If Me.DataGridView1.RowCount < 20 Then
            Me.DataGridView1.RowCount = 20
            Me.DataGridView2.RowCount = 20
        End If

        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    'ファイル
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim files As String() = SelectFiles(srcPath)
        If files Is Nothing Then Exit Sub
        Dim fileI As String

        'DataGridView1ファイル名追加
        'DataGridView2ファイル名追加
        Me.DataGridView1.Rows.Clear()
        Me.DataGridView2.Rows.Clear()
        Dim i As Int32 = 0
        For Each fileI In files
            If Path.GetExtension(fileI).ToLower = ".ts" Then
                setFilesToDataGridView(i, fileI)
                i += 1
            End If
        Next
        If Me.DataGridView1.RowCount < 20 Then
            Me.DataGridView1.RowCount = 20
            Me.DataGridView2.RowCount = 20
        End If

        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    '全クリア
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        For i As Int32 = 0 To Me.DataGridView1.RowCount - 2
            Me.DataGridView1.Rows.RemoveAt(0)
            Me.DataGridView2.Rows.RemoveAt(0)
        Next

        Me.DataGridView1.Columns(0).Width = Me.DataGridView1.Width - Me.DataGridView1.Columns(1).Width - DataGriedViewScrollBWidth
        Me.DataGridView2.Columns(1).Width = DataGriedViewColum1Width
        Dim nWidth As Int32 = Me.DataGridView2.Width - DataGriedViewColum1Width - DataGriedViewColum2Width - DataGriedViewColum3Width - DataGriedViewScrollBWidth
        If nWidth < DataGriedViewColum0Width Then
            Me.DataGridView2.Columns(0).Width = DataGriedViewColum0Width
        Else
            Me.DataGridView2.Columns(0).Width = nWidth
        End If
        Me.DataGridView1.RowCount = 20
        Me.DataGridView2.RowCount = 20
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    '選択クリア
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim dgv1 As DataGridView = Me.DataGridView1
        Dim dgv2 As DataGridView = Me.DataGridView2
        If dgv1.SelectedRows.Count < 1 Then Exit Sub

        Dim r As DataGridViewRow
        For Each r In dgv1.SelectedRows
            If Not r.IsNewRow Then
                dgv2.Rows.RemoveAt(r.Index)
                dgv1.Rows.Remove(r)
            End If
        Next r
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()
        Dim VItemWidth As Int32
        Dim V1Item0Width As Int32 = DataGriedViewColum0Width
        Dim V2Item0Width As Int32 = DataGriedViewColum0Width
        Dim V2Item1Width As Int32 = DataGriedViewColum1Width
        For i As Int32 = 0 To Me.DataGridView1.Rows.Count - 1
            VItemWidth = CInt(g.MeasureString(dgv1(0, i).Value, dgv1.Font, Integer.MaxValue, sf).Width)
            If V1Item0Width < VItemWidth Then V1Item0Width = VItemWidth
            VItemWidth = CInt(g.MeasureString(dgv2(0, i).Value, dgv2.Font, Integer.MaxValue, sf).Width)
            If V2Item0Width < VItemWidth Then V2Item0Width = VItemWidth
            VItemWidth = CInt(g.MeasureString(dgv2(1, i).Value, dgv2.Font, Integer.MaxValue, sf).Width)
            If V2Item1Width < VItemWidth Then V2Item1Width = VItemWidth
        Next

        If dgv1.Width < dgv1.Columns(0).Width + dgv1.Columns(1).Width + 20 Then
            VItemWidth = dgv1.Width - dgv1.Columns(1).Width - 20
            If V1Item0Width < VItemWidth Then
                dgv1.Columns(0).Width = VItemWidth
            End If
        End If
        If dgv2.Width < dgv2.Columns(0).Width + dgv2.Columns(1).Width + dgv2.Columns(2).Width + dgv2.Columns(3).Width + 20 Then
            'Column1
            VItemWidth = dgv2.Width - dgv2.Columns(0).Width - dgv2.Columns(2).Width - dgv2.Columns(3).Width - 20
            If V2Item1Width < VItemWidth Then
                dgv2.Columns(1).Width = VItemWidth
            Else
                dgv2.Columns(1).Width = V2Item1Width
            End If
            'Column0
            VItemWidth = dgv2.Width - dgv2.Columns(1).Width - dgv2.Columns(2).Width - dgv2.Columns(3).Width - 20
            If V2Item0Width < VItemWidth Then
                dgv2.Columns(0).Width = VItemWidth
            Else
                dgv2.Columns(0).Width = V2Item0Width
            End If

        End If
        If dgv1.RowCount < 20 Then
            dgv1.RowCount = 20
            dgv2.RowCount = 20
        End If
        dgv1.ClearSelection()
        dgv2.ClearSelection()

    End Sub

    Private dgvRowIndex As Int32
    Private ItemWidth As Int32

    '開始
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        If bIsExecute = True Then Exit Sub
        If String.IsNullOrEmpty(Me.DataGridView1(0, 0).Value) Then
            bIsExecute = False
            Exit Sub
        End If
        bIsExecute = True
        Me.ControlBox = False
        Me.Button1.Enabled = False
        Me.Button2.Enabled = False
        Me.Button4.Enabled = False
        Me.Button3.Enabled = False
        Me.ListBox1.Items.Add("")
        ListColor.Add(0)

        Dim psi As New System.Diagnostics.ProcessStartInfo()
        Dim pId As New System.Diagnostics.Process
        psi.FileName = System.Environment.GetEnvironmentVariable("ComSpec") 'ComSpecのパスを取得する
        psi.RedirectStandardInput = False   '標準入力を読取らない
        psi.RedirectStandardOutput = True   '標準出力をリダイレクトする
        psi.RedirectStandardError = True    '標準エラー出力を　　〃
        psi.UseShellExecute = False         'シェルは使えない
        psi.CreateNoWindow = True           'ウィンドウを表示しないようにする

        Dim srcFileName As String
        Dim dstFileName As String

        For i As Int32 = 0 To Me.DataGridView1.RowCount - 1
            If (Not String.IsNullOrEmpty(Me.DataGridView1(0, i).Value)) And (Not String.IsNullOrEmpty(Path.GetDirectoryName(Me.DataGridView2(0, i).Value))) Then
                dgvRowIndex = i
                srcFileName = Me.DataGridView1(0, i).Value
                dstFileName = Me.DataGridView2(0, i).Value
                If 0 < i Then
                    Me.DataGridView1.Rows(i - 1).Selected = False
                    Me.DataGridView2.Rows(i - 1).Selected = False
                End If
                Me.DataGridView1.Rows(i).Selected = True
                Me.DataGridView2.Rows(i).Selected = True
                Me.Button5.ForeColor = Color.DarkRed
                Me.Button5.Image = My.Resources.ajax_loader_2

                Try
                    'コマンドラインを指定（"/c"は実行後閉じるために必要）
                    Dim AppPath As String = Application.ExecutablePath.ToString
                    'psi.Arguments = "/c " + AppPath.Substring(0, AppPath.IndexOf("TsTimeKeeperGUI.exe", StringComparison.OrdinalIgnoreCase)) + "TsTimeKeeper.exe" + " " + """" + srcFileName + """" + " " + """" + dstFileName + """"
                    psi.Arguments = "/c TsTimeKeeper.exe" + " " + """" + srcFileName + """" + " " + """" + dstFileName + """"
                    '起動
                    pId = System.Diagnostics.Process.Start(psi)
                    '出力の監視を開始
                    Me.Invoke(WriteListBox1Instance, New Object() {&HD})
                    Me.Invoke(WriteListBox1Instance, New Object() {&HA})

                    Dim stdoutWatcher = New Thread(New ParameterizedThreadStart(AddressOf standardOutputWatcherThread))
                    stdoutWatcher.Start(pId.StandardOutput)
                    Dim stderrWatcher = New Thread(New ParameterizedThreadStart(AddressOf standardErrorWatcherThread))
                    stderrWatcher.Start(pId.StandardError)
                    Do While stderrWatcher.IsAlive = True
                        System.Threading.Thread.Sleep(1)
                        System.Windows.Forms.Application.DoEvents()
                    Loop

                    System.Threading.Thread.Sleep(20)

                    pId.Close()
                    pId.Dispose()
                    pId = Nothing

                Catch ex As System.Exception
                    'ex.MessageにはCrLfが入ってないので足しておく
                    WriteListBox1ErrorString(vbCrLf + ex.Message + vbCrLf)

                    pId.Close()
                    pId.Dispose()
                    pId = Nothing
                    Exit For

                End Try

            End If
        Next

        Me.Button5.Image = Nothing
        Me.Button5.ForeColor = Color.Black
        Me.Button5.Text = "開始"
        Me.Button1.Enabled = True
        Me.Button2.Enabled = True
        Me.Button4.Enabled = True
        Me.Button3.Enabled = True
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()
        Me.ControlBox = True
        bIsExecute = False

    End Sub

    '強制終了
    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim lngProcessSnapHandle As Long
        Dim udtProcessEntry32 As New PROCESSENTRY32
        Dim strProcessID As String
        Dim strExeFileName As String
        Dim lngWin32apiResultCode As Long
        Dim h32ProcessID As Int32

        ' プロセスのスナップショットを取得
        lngProcessSnapHandle = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)
        ' プロセスのスナップショットを取得できない場合は
        If lngProcessSnapHandle = (-1) Then
            ' エラーを表示して終了
            MsgBox("スナップショットの取得は失敗")
            Exit Sub
        End If
        ' プロセスエントリを定義する構造体を初期化
        udtProcessEntry32.dwSize = Marshal.SizeOf(udtProcessEntry32)
        ' 最初のプロセスエントリを取得できたときは
        If Process32First(lngProcessSnapHandle, udtProcessEntry32) <> False Then
            ' 2番目以降のプロセスエントリを取得できる間は
             Do
                ' プロセスIDと実行ファイルのフルパス名を取り出し
                With udtProcessEntry32
                    strProcessID = Hex(.th32ProcessID)
                    strExeFileName = .szExeFile.ToString
                    'MsgBox(strExeFileName)
                    'strExeFileName = Microsoft.VisualBasic.Left(strExeFileName, InStr(strExeFileName, vbNullChar) - 1)
                    ' プロセスIDと実行ファイルのフルパス名を追加
                    If -1 < strExeFileName.IndexOf("TsTimeKeeper.exe", StringComparison.OrdinalIgnoreCase) Then
                        h32ProcessID = .th32ProcessID
                    End If
                End With
                'i = i + 1
                ' 次のプロセスエントリを取得
            Loop While Process32Next(lngProcessSnapHandle, udtProcessEntry32) <> False
        Else        ' エラーを表示して終了
            MsgBox("プロセスエントリの取得は失敗")
            Exit Sub
        End If
        ' プロセスのスナップショットを開放
        lngWin32apiResultCode = CloseHandle(lngProcessSnapHandle)

        ProcessTerminate(h32ProcessID)

        System.Threading.Thread.Sleep(1000)

        ForeColorDataGridView2(3, dgvRowIndex, System.Drawing.Color.Red)
        Me.DataGridView2(3, dgvRowIndex).Value = "強制終了"
        Me.ControlBox = True

    End Sub

    'DataGridViewのプロパティAllowDropをTrueに
    Private dragBoxFromMouseDown As Rectangle
    Private rowIndexFromMouseDown As Integer
    Private rowIndexOfItemUnderMouseToDrop As Integer
    Dim listRowIndexSelect As List(Of Integer) = New List(Of Integer)

    Private Sub DataGridView1_CellMouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView1.CellMouseMove
        If (e.Button And MouseButtons.Left) = MouseButtons.Left Then
            ' If the mouse moves outside the rectangle, start the drag.
            If dragBoxFromMouseDown <> Rectangle.Empty And Not dragBoxFromMouseDown.Contains(e.X, e.Y) Then
                ' Proceed with the drag and drop, passing in the list item.
                Dim dropEffect As DragDropEffects = Me.DataGridView1.DoDragDrop(Me.DataGridView1.Rows(rowIndexFromMouseDown), DragDropEffects.Move)
            End If
        End If

    End Sub

    Private Sub DataGridView1_ColumnHeaderMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView1.ColumnHeaderMouseClick
        If bIsExecute Then Exit Sub
        'Dim i As Int32
        'For i = 0 To Me.DataGridView1.RowCount - 1
        '    If String.IsNullOrEmpty(Me.DataGridView1(0, i).Value) Then Exit For
        'Next
        'Me.DataGridView1.RowCount = i + 1
        Dim j As Int32 = 0
        Dim dgvRowCount As Int32 = Me.DataGridView1.RowCount
        For i As Int32 = 0 To dgvRowCount - 1
            If Me.DataGridView1.NewRowIndex = i Then Exit For
            If String.IsNullOrEmpty(Me.DataGridView1(0, i).Value) Then
                Me.DataGridView1.Rows.RemoveAt(j)
                dgvRowCount -= 1
                i -= 1
            Else
                j += 1
            End If
        Next
        Me.DataGridView1.RowCount = dgvRowCount

        If _sorder = SortOrder.Ascending Then
            _sorder = SortOrder.Descending
        Else
            _sorder = SortOrder.Ascending
        End If
        DataGridView1.Sort(New CustomComparer(_sorder))

        If Me.DataGridView1.RowCount < 20 Then
            DataGridView1.RowCount = 20
        End If

        Me.DataGridView2.Rows.Clear()
        Me.DataGridView2.RowCount = Me.DataGridView1.RowCount
        setFilesFromDataGriedVew1()
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    Private Sub DataGridView1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles DataGridView1.DragDrop
        If e.Data.GetDataPresent(GetType(DataGridViewRow)) Then
            listRowIndexSelect.Clear()
            Dim dgvr As DataGridViewRow
            For Each dgvr In Me.DataGridView1.Rows
                If dgvr.Selected Then
                    listRowIndexSelect.Add(dgvr.Index)
                End If
            Next dgvr

            ' 以下の３行は好み。行が反転されている場合のみ移動対象にする場合は以下の３行はコメントアウト。
            'そうではなく、行が反転されているかどうかにかかわらず、最後にクリックした行を移動させる場合は、以下の３行を生かす。
            'If Not Me.DataGridView1.Rows(rowIndexFromMouseDown).Selected Then
            '    listRowIndexSelect.Add(rowIndexFromMouseDown)
            'End If

            ' The mouse locations are relative to the screen, so they must be 
            ' converted to client coordinates.
            Dim clientPoint As Point = Me.DataGridView1.PointToClient(New Point(e.X, e.Y))

            ' Get the row index of the item the mouse is below. 
            rowIndexOfItemUnderMouseToDrop = Me.DataGridView1.HitTest(clientPoint.X, clientPoint.Y).RowIndex

            ' If the drag operation was a move then remove and insert the row.
            If e.Effect = DragDropEffects.Move Then
                'データセットにバインドしていない場合
                Dim rowToMove As DataGridViewRow = e.Data.GetData(GetType(DataGridViewRow))
                DataGridView1.Rows.RemoveAt(rowIndexFromMouseDown)
                DataGridView1.Rows.Insert(rowIndexOfItemUnderMouseToDrop, rowToMove)

                'データセットにバインドしている場合
                '' get the row data from row before removing and add to new row
                'Dim listDataRow As List(Of DataRow) = New List(Of DataRow)  '挿入する行を作成し、保持する
                'Dim rowIndex As Integer
                'For Each rowIndex In listRowIndexSelect
                '    Dim rowArray As Object() = testdbDataSet.TEST.Rows(rowIndex).ItemArray
                '    Dim row As DataRow = testdbDataSet.TEST.NewRow()
                '    row.ItemArray = rowArray
                '    listDataRow.Add(row)
                'Next rowIndex

                ''  remove old row and insert new row
                'Dim index As Integer = 0
                'Dim delcntBeforeRowIndexOfItemUnderMouseToDrop As Integer = 0 'ドロップ先の行以前に存在する選択された行数
                ''選択された行を削除する
                ''Dim rowIndex As Integer
                'For Each rowIndex In listRowIndexSelect
                '    '行を削除する度に行インデックスが一つ減るので、それを調整しながら削除
                '    testdbDataSet.TEST.Rows.RemoveAt((rowIndex - index))
                '    index += 1

                '    If rowIndex <= rowIndexOfItemUnderMouseToDrop Then
                '        delcntBeforeRowIndexOfItemUnderMouseToDrop += 1
                '    End If
                'Next rowIndex
                ''行を挿入します。ドロップ先の行以前にある行数分、ドロップ先行のインデックスが減る
                ''なぜなら、すぐ上で行を削除しているから
                'Dim i As Integer
                'For i = listDataRow.Count - 1 To 0 Step -1
                '    testdbDataSet.TEST.Rows.InsertAt(listDataRow(i), rowIndexOfItemUnderMouseToDrop - delcntBeforeRowIndexOfItemUnderMouseToDrop)
                'Next i
            End If

            Me.DataGridView2.Rows.Clear()
            Me.DataGridView2.RowCount = Me.DataGridView1.RowCount
            setFilesFromDataGriedVew1()
            Me.DataGridView1.ClearSelection()
            Me.DataGridView2.ClearSelection()

        Else
            'コントロール内にドロップされたとき実行される
            'ドロップされたすべてのファイル名を取得する
            Dim files As String() = CType(e.Data.GetData(DataFormats.FileDrop, False), String())

            'DataGridView1ファイル名追加
            'DataGridView2ファイル名追加
            'Ver 3.3.14.11------------------------------------------------------------------------------
            'Me.DataGridView1.Rows.Clear()
            'Me.DataGridView2.Rows.Clear()
            Dim i As Int32
            For i = 0 To Me.DataGridView1.RowCount - 1
                If String.IsNullOrEmpty(Me.DataGridView1(0, i).Value) Then Exit For
            Next
            'Dim i As Int32 = 0
            '-------------------------------------------------------------------------------------------
            Dim fileI As String
            For Each fileI In files
                If Path.GetExtension(fileI).ToLower = ".ts" Then
                    setFilesToDataGridView(i, fileI)
                    i += 1
                End If
            Next
            If Me.DataGridView1.RowCount < 20 Then
                Me.DataGridView1.RowCount = 20
                Me.DataGridView2.RowCount = 20
            End If
            Me.DataGridView1.ClearSelection()
            Me.DataGridView2.ClearSelection()

        End If

    End Sub

    Private Sub DataGridView1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles DataGridView1.DragEnter
        'コントロール内にドラッグされたとき実行される
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If

    End Sub

    Private Sub DataGridView1_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles DataGridView1.DragOver
        e.Effect = DragDropEffects.Move

    End Sub

    Private Sub DataGridView1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGridView1.MouseDown
        ' Get the index of the item the mouse is below.
        rowIndexFromMouseDown = Me.DataGridView1.HitTest(e.X, e.Y).RowIndex

        If rowIndexFromMouseDown <> -1 Then
            ' Remember the point where the mouse down occurred. 
            ' The DragSize indicates the size that the mouse can move 
            ' before a drag event should be started.                
            Dim dragSize As Size = SystemInformation.DragSize

            ' Create a rectangle using the DragSize, with the mouse position being
            ' at the center of the rectangle.
            dragBoxFromMouseDown = New Rectangle(New Point(e.X - dragSize.Width / 2, e.Y - dragSize.Height / 2), dragSize)
            ' Reset the rectangle if the mouse is not over an item in the ListBox.
        Else
            dragBoxFromMouseDown = Rectangle.Empty
        End If

    End Sub

    Private Sub DataGridView1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DataGridView1.MouseMove
        If (e.Button And MouseButtons.Left) = MouseButtons.Left Then
            ' If the mouse moves outside the rectangle, start the drag.
            If dragBoxFromMouseDown <> Rectangle.Empty And Not dragBoxFromMouseDown.Contains(e.X, e.Y) Then
                ' Proceed with the drag and drop, passing in the list item.
                Dim dropEffect As DragDropEffects = Me.DataGridView1.DoDragDrop(Me.DataGridView1.Rows(rowIndexFromMouseDown), DragDropEffects.Move)
            End If
        End If

    End Sub









    Private Sub Form1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragDrop
        'コントロール内にドロップされたとき実行される
        'ドロップされたすべてのファイル名を取得する
        Dim files As String() = CType(e.Data.GetData(DataFormats.FileDrop, False), String())
        'ドロップされたファイルのパスをすべて表示
        Me.DataGridView1.Rows.Clear()
        Me.DataGridView2.Rows.Clear()

        Dim fileI As String
        Dim i As Int32 = 0
        If 0 < files.Length Then
            For Each fileI In files
                If Path.GetExtension(fileI).ToLower = ".ts" Then
                    setFilesToDataGridView(i, fileI)
                    i += 1
                End If
            Next
        End If
        If DataGridView1.RowCount < 20 Then
            Me.DataGridView1.RowCount = 20
            Me.DataGridView2.RowCount = 20
        End If
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    Private Sub Form1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragEnter
        'コントロール内にドラッグされたとき実行される
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim fileName As String = Application.StartupPath + "\settings.config"
        If System.IO.File.Exists(fileName) Then
            Dim appSettings As New Settings
            Dim bf2 As New BinaryFormatter
            Dim fs2 As New System.IO.FileStream(fileName, System.IO.FileMode.Open)
            appSettings = CType(bf2.Deserialize(fs2), Settings)
            fs2.Close()
            '変数に設定
            With appSettings
                srcPath = .srcPath
                dstPath = .dstPath
            End With
            appSettings = Nothing
            If Not System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(srcPath)) Then srcPath = ""
            If Not System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(dstPath)) Then dstPath = ""
        Else
            srcPath = ""
            dstPath = ""
        End If

        'ドロップされたファイルのパスをすべて表示
        Me.DataGridView1.DefaultCellStyle.SelectionBackColor = SystemColors.InactiveCaption
        Me.DataGridView2.DefaultCellStyle.SelectionBackColor = SystemColors.InactiveCaption
        Me.DataGridView1.DefaultCellStyle.SelectionForeColor = Color.Black
        Me.DataGridView2.DefaultCellStyle.SelectionForeColor = Color.Black
        Me.DataGridView1.Rows.Clear()
        Me.DataGridView2.Rows.Clear()

        Dim cmds As String() = System.Environment.GetCommandLineArgs()
        Dim fileI As String
        Dim i As Int32 = 0
        Dim j As Int32 = 0
        If 1 < cmds.Length Then
            For Each fileI In cmds
                If 0 < i Then
                    If Path.GetExtension(fileI).ToLower = ".ts" Then
                        setFilesToDataGridView(j, fileI)
                        j += 1
                    End If
                End If
                i += 1
            Next

        End If
        If DataGridView1.RowCount < 20 Then
            Me.DataGridView1.RowCount = 20
            Me.DataGridView2.RowCount = 20
        End If
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Me.ResizeRedraw = False
        If 597 < Me.Width Then
            Dim xx As Int32 = Me.Width - Me.DataGridView1.Width - (597 - 494)
            'DataGridView
            Me.DataGridView1.Width += xx
            Me.DataGridView2.Width += xx
            If DataGriedViewColum0Width < Me.DataGridView1.Width - (DataGriedViewColum1Width + DataGriedViewScrollBWidth) Then
                Me.DataGridView1.Columns(0).Width = Me.DataGridView1.Width - DataGriedViewColum1Width - DataGriedViewScrollBWidth
            End If
            If DataGriedViewColum0Width < Me.DataGridView2.Width - (Me.DataGridView2.Columns(1).Width + DataGriedViewColum2Width + DataGriedViewColum3Width + DataGriedViewScrollBWidth) Then
                Me.DataGridView2.Columns(0).Width = Me.DataGridView2.Width - (Me.DataGridView2.Columns(1).Width + Me.DataGridView2.Columns(2).Width + Me.DataGridView2.Columns(3).Width + DataGriedViewScrollBWidth)
            End If
            'Button
            Me.Button1.Left += xx
            Me.Button2.Left += xx
            Me.Button3.Left += xx
            Me.Button4.Left += xx
            Me.Button5.Left += xx
        End If
        If 496 < Me.Height Then
            Dim yy As Int32 = (Me.Height - Me.DataGridView1.Height - Me.DataGridView2.Height - (496 - 175 * 2)) \ 2
            'DataGrid
            Me.DataGridView1.Height += yy
            Me.DataGridView2.Top += yy
            Me.DataGridView2.Height += yy
            'label
            Me.Label2.Top += yy
            'Button
            Me.Button3.Top += yy
            Me.Button4.Top += yy
            Me.Button5.Top += yy * 2
            Me.Button6.Top += yy * 2
        End If
        Me.ResizeRedraw = True

    End Sub

    Private Sub 入出力設定ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 入出力設定ToolStripMenuItem.Click
        If bIsExecute Then Exit Sub
        Dim fm As New Form2
        Dim prevsrcPath As String = srcPath
        Dim prevdstPath As String = dstPath
        fm.ShowDialog(Me)
        fm.Dispose()
        If Not prevsrcPath = srcPath Then
            '全クリア
            Button3_Click(sender, e)
        End If
        If Not prevdstPath = dstPath Then
            setFilesFromDataGriedVew1()
            Me.DataGridView1.ClearSelection()
            Me.DataGridView2.ClearSelection()
        End If

    End Sub

    Private Sub バージョン情報ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles バージョン情報ToolStripMenuItem.Click
        MsgBox("    TsTimeKeeperGUI" + vbCrLf + _
               "       Ver3.3.14.11")

    End Sub

    Private Sub setFilesFromDataGriedVew1()
        Dim fileI As String
        Dim fileO As String

        For i As Int32 = 0 To Me.DataGridView1.RowCount - 1
            fileI = Me.DataGridView1(0, i).Value
            If String.IsNullOrEmpty(fileI) Then Continue For
            fileO = dstPath
            If String.IsNullOrEmpty(dstPath) Then
                fileO = Path.GetDirectoryName(fileI)
            End If
            If Not (fileO.Substring(fileO.Length - 1, 1) = "\") Then fileO += "\"
            fileO += (Path.GetFileNameWithoutExtension(fileI) + ".000" + Path.GetExtension(fileI))
            Me.DataGridView2(0, i).Value = fileO
        Next

    End Sub

    Private Sub setFilesToDataGridView(ByVal i As Int32, ByVal fileI As String)
        Dim fileO As String
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()
        Dim ItemWidth As Int32

        If Path.GetExtension(fileI).ToLower = ".ts" Then
            Me.DataGridView1.RowCount += 1
            Me.DataGridView2.RowCount += 1
            Me.DataGridView1(0, i).Value = fileI
            ItemWidth = CInt(g.MeasureString(fileI, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
            If Me.DataGridView1.Columns(0).Width < ItemWidth Then Me.DataGridView1.Columns(0).Width = ItemWidth
            Me.DataGridView1(1, i).Value = System.IO.File.GetLastWriteTime(fileI)
            fileO = dstPath
            If String.IsNullOrEmpty(dstPath) Then
                fileO = Path.GetDirectoryName(fileI)
            End If
            If Not (fileO.Substring(fileO.Length - 1, 1) = "\") Then fileO += "\"
            fileO += (Path.GetFileNameWithoutExtension(fileI) + ".000" + Path.GetExtension(fileI))
            Me.DataGridView2(0, i).Value = fileO
            ItemWidth = CInt(g.MeasureString(fileO, Me.DataGridView2.Font, Integer.MaxValue, sf).Width)
            If Me.DataGridView2.Columns(0).Width < ItemWidth Then Me.DataGridView2.Columns(0).Width = ItemWidth
        End If

    End Sub

    Private Sub WriteButton5Text(ByVal Value As String)
        Button5.Text = Value

    End Sub

    Private Sub WriteDataGridView2(ByVal i As Int32, ByVal Value As String)
        DataGridView2(1, i).Value = Value

    End Sub

    Private Sub ForeColorDataGridView2(ByVal nCol As Int32, ByVal nRow As Int32, ByVal Value As System.Drawing.Color)
        DataGridView2(nCol, nRow).Style.ForeColor = Value

    End Sub

    Private List1Index As Int32 = 0
    Private Push As Byte
    Private sTmp As New System.Text.StringBuilder()
    Private sTmpS As New System.Text.StringBuilder()
    Private sTmpE As New System.Text.StringBuilder()
    Private sTmpES As New System.Text.StringBuilder()
    Private ListColor As New List(Of Int32)
    Private stdIn As Int32 = 0
    Private strDGV As String = ""
    Private strDGVSV As String = ""

    '標準出力監視スレッド
    Private Sub standardOutputWatcherThread(ByVal parameter As Object)
        Dim reader As System.IO.StreamReader = parameter
        stdIn = 1
        Do
            Me.Invoke(WriteListBox1Instance, New Object() {reader.Read()})
        Loop Until reader.EndOfStream
        reader.Close()
        stdIn = 0

    End Sub

    '標準エラー出力監視スレッド
    Private Sub standardErrorWatcherThread(ByVal parameter As Object)
        Dim reader As System.IO.StreamReader = parameter
        Do
            System.Threading.Thread.Sleep(10)
        Loop Until stdIn = 0
        Do
            Me.Invoke(WriteListBox1ErrorInstance, New Object() {reader.Read()})
        Loop Until reader.EndOfStream
        reader.Close()

    End Sub

    Private Sub WriteListBox1(ByVal Value As Int32)
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()

        Select Case Value
            Case 0
            Case &HD
                Push = &HD
            Case &HA
                If Push = &HD Then
                    If sTmp.Length < ListBox1.Items(List1Index).Length Then
                        sTmp.Append(ListBox1.Items(List1Index).ToString.Substring(sTmp.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmp.ToString
                    ListBox1.Items.Add("")
                    ListColor.Add(0)
                    Push = 0
                    List1Index += 1
                    If -1 < sTmp.ToString.IndexOf("開始時刻") Then
                        Me.DataGridView2(2, dgvRowIndex).Value = sTmp.ToString.Substring(5).Trim
                    ElseIf -1 < sTmp.ToString.IndexOf("終了時刻") Then
                        Me.DataGridView2(3, dgvRowIndex).Value = sTmp.ToString.Substring(5).Trim
                    ElseIf -1 < sTmp.ToString.IndexOf("更新完了") Then
                        strDGV = "PCR,PTS,DTS 更新完了 100%"
                    End If
                    If Not strDGV.Equals(strDGVSV) Then
                        Me.DataGridView2(1, dgvRowIndex).Value = strDGV
                        ItemWidth = CInt(g.MeasureString(strDGV, Me.DataGridView2.Font, Integer.MaxValue, sf).Width)
                        If Me.DataGridView2.Columns(1).Width < ItemWidth Then Me.DataGridView2.Columns(1).Width = ItemWidth
                        strDGVSV = strDGV
                    End If
                    sTmp.Remove(0, sTmp.Length)

                Else
                    sTmp.Append(ChrW(Value))
                End If

            Case Else
                If Push = &HD Then
                    If sTmp.Length < ListBox1.Items(List1Index).Length Then
                        sTmp.Append(ListBox1.Items(List1Index).ToString.Substring(sTmp.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmp.ToString
                    If -1 < sTmp.ToString.IndexOf("検索中") Then
                        Me.Button5.Text = sTmp.ToString.Substring(20).Trim
                        strDGV = "PAT,PMT,GOP,PCR 検索中"
                    ElseIf -1 < sTmp.ToString.IndexOf("更新中") Then
                        Me.Button5.Text = sTmp.ToString.Substring(16).Trim
                        strDGV = "PCR,PTS,DTS 更新中"
                    End If
                    If Not strDGV.Equals(strDGVSV) Then
                        Me.DataGridView2(1, dgvRowIndex).Value = strDGV
                        ItemWidth = CInt(g.MeasureString(strDGV, Me.DataGridView2.Font, Integer.MaxValue, sf).Width)
                        If Me.DataGridView2.Columns(1).Width < ItemWidth Then Me.DataGridView2.Columns(1).Width = ItemWidth
                        strDGVSV = strDGV
                    End If

                    sTmp.Remove(0, sTmp.Length)
                    Push = 0
                End If
                sTmp.Append(ChrW(Value))

        End Select

    End Sub

    Private Sub WriteListBox1String(ByVal Value As String)
        sTmpS.Append(Value)
        Select Case AscW(sTmpS(sTmpS.Length - 1))
            Case &HA
                If AscW(sTmpS(sTmpS.Length - 2)) = &HD Then
                    sTmpS.Remove(sTmpS.Length - 2, 2)
                    If sTmpS.Length < ListBox1.Items(List1Index).Length Then
                        sTmpS.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpS.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmpS.ToString
                    ListColor.Item(List1Index) = 1
                    ListBox1.Items.Add("")
                    ListColor.Add(0)
                    List1Index += 1
                    sTmpS.Remove(0, sTmpS.Length)
                End If

            Case &HD
                sTmpS.Remove(sTmpS.Length - 1, 1)
                If sTmpS.Length < ListBox1.Items(List1Index).Length Then
                    sTmpS.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpS.Length))
                End If
                ListBox1.Items(List1Index) = sTmpS.ToString
                ListColor.Item(List1Index) = 1
                sTmpS.Remove(0, sTmpS.Length)

        End Select

    End Sub

    Private Sub WriteListBox1Error(ByVal Value As Int32)
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()

        Select Case Value
            Case 0
            Case &HD
                Push = &HD
            Case &HA
                If Push = &HD Then
                    If sTmpE.Length < ListBox1.Items(List1Index).Length Then
                        sTmpE.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpE.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmpE.ToString
                    ListColor.Item(List1Index) = 1
                    ListBox1.Items.Add("")
                    ListColor.Add(0)
                    Push = 0
                    List1Index += 1

                    ForeColorDataGridView2(1, dgvRowIndex, System.Drawing.Color.Red)
                    Me.DataGridView2(1, dgvRowIndex).Value = sTmpE.ToString
                    ItemWidth = CInt(g.MeasureString(strDGV, Me.DataGridView2.Font, Integer.MaxValue, sf).Width)
                    If Me.DataGridView2.Columns(1).Width < ItemWidth Then Me.DataGridView2.Columns(1).Width = ItemWidth

                    sTmpE.Remove(0, sTmpE.Length)
                Else
                    sTmpE.Append(ChrW(Value))
                End If

            Case Else
                If Push = &HD Then
                    If sTmpE.Length < ListBox1.Items(List1Index).Length Then
                        sTmpE.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpE.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmpE.ToString
                    ListColor.Item(List1Index) = 1

                    ForeColorDataGridView2(1, dgvRowIndex, System.Drawing.Color.Red)
                    Me.DataGridView2(1, dgvRowIndex).Value = sTmpE.ToString
                    ItemWidth = CInt(g.MeasureString(strDGV, Me.DataGridView2.Font, Integer.MaxValue, sf).Width)
                    If Me.DataGridView2.Columns(1).Width < ItemWidth Then Me.DataGridView2.Columns(1).Width = ItemWidth

                    sTmpE.Remove(0, sTmpE.Length)
                    Push = 0
                End If
                sTmpE.Append(ChrW(Value))

        End Select

    End Sub

    Private Sub WriteListBox1ErrorString(ByVal Value As String)
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()

        sTmpES.Append(Value)
        Select Case AscW(sTmpES(sTmpES.Length - 1))
            Case &HA
                If AscW(sTmpES(sTmpES.Length - 2)) = &HD Then
                    sTmpES.Remove(sTmpES.Length - 2, 2)
                    If sTmpES.Length < ListBox1.Items(List1Index).Length Then
                        sTmpES.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpES.Length))
                    End If
                    ListBox1.Items(List1Index) = sTmpES.ToString
                    ListColor.Item(List1Index) = 1
                    ListBox1.Items.Add("")
                    ListColor.Add(0)
                    List1Index += 1
                    ForeColorDataGridView2(1, dgvRowIndex, System.Drawing.Color.Red)
                    Me.DataGridView2(1, dgvRowIndex).Value = sTmpES.ToString
                    ItemWidth = CInt(g.MeasureString(strDGV, Me.DataGridView2.Font, Integer.MaxValue, sf).Width)
                    If Me.DataGridView2.Columns(1).Width < ItemWidth Then Me.DataGridView2.Columns(1).Width = ItemWidth

                    sTmpES.Remove(0, sTmpES.Length)
                End If

            Case &HD
                sTmpES.Remove(sTmpES.Length - 1, 1)
                If sTmpES.Length < ListBox1.Items(List1Index).Length Then
                    sTmpES.Append(ListBox1.Items(List1Index).ToString.Substring(sTmpES.Length))
                End If
                ListBox1.Items(List1Index) = sTmpES.ToString
                ListColor.Item(List1Index) = 1
                ForeColorDataGridView2(1, dgvRowIndex, System.Drawing.Color.Red)
                Me.DataGridView2(1, dgvRowIndex).Value = sTmpES.ToString
                ItemWidth = CInt(g.MeasureString(strDGV, Me.DataGridView2.Font, Integer.MaxValue, sf).Width)
                If Me.DataGridView2.Columns(1).Width < ItemWidth Then Me.DataGridView2.Columns(1).Width = ItemWidth

                sTmpES.Remove(0, sTmpES.Length)

        End Select

    End Sub

End Class

'IComparerインターフェイスを実装した、並び替える方法を定義したクラス
Public Class CustomComparer
    Implements IComparer
    Private sOrder As Integer
    Private comparer As Comparer

    Public Sub New(ByVal order As SortOrder)
        Me.sOrder = IIf(order = SortOrder.Descending, -1, 1)
        Me.comparer = New Comparer(System.Globalization.CultureInfo.CurrentCulture)

    End Sub

    '並び替え方を定義する
    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
        Dim result As Integer = 0

        Dim rowx As DataGridViewRow = CType(x, DataGridViewRow)
        Dim rowy As DataGridViewRow = CType(y, DataGridViewRow)
        'Ver 3.3.14.11---------------------------------------------------------------------------
        Dim strX As New StringBuilder
        Dim strY As New StringBuilder
        Dim intX As Int32 = 0
        '----------------------------------------------------------------------------------------
        'はじめの列のセルの値を比較し、同じならば次の列を比較する
        For i As Integer = 0 To rowx.Cells.Count - 1
            'Ver 3.3.14.11------------------------------------------------------------------------
            For j As Int32 = 0 To rowx.Cells(i).Value.ToString.Length - 1
                If Not IsNumeric(rowx.Cells(i).Value.ToString.Substring(j, 1)) Then
                    If intX <> 0 Then
                        strX.Append(("0000000000" + CStr(intX)).Substring(CStr(intX).Length))
                        intX = 0
                    End If
                    strX.Append(rowx.Cells(i).Value.ToString.Substring(j, 1))
                Else
                    intX = intX * 10 + CInt(rowx.Cells(i).Value.ToString.Substring(j, 1))
                End If
            Next
            If intX <> 0 Then
                strX.Append(("0000000000" + CStr(intX)).Substring(CStr(intX).Length))
                intX = 0
            End If

            For j As Int32 = 0 To rowy.Cells(i).Value.ToString.Length - 1
                If Not IsNumeric(rowy.Cells(i).Value.ToString.Substring(j, 1)) Then
                    If intX <> 0 Then
                        strY.Append(("0000000000" + CStr(intX)).Substring(CStr(intX).Length))
                        intX = 0
                    End If
                    strY.Append(rowy.Cells(i).Value.ToString.Substring(j, 1))
                Else
                    intX = intX * 10 + CInt(rowy.Cells(i).Value.ToString.Substring(j, 1))
                End If
            Next
            If intX <> 0 Then
                strY.Append(("0000000000" + CStr(intX)).Substring(CStr(intX).Length))
                intX = 0
            End If
            '----------------------------------------------------------------------------------
            result = Me.comparer.Compare(rowx.Cells(i).Value, rowy.Cells(i).Value)
            If result <> 0 Then
                Exit For
            End If
            'Ver 3.3.14.11---------------------------------------------------------------------
            strX.Remove(0, strX.Length)
            strY.Remove(0, strY.Length)
            '---------------------------------------------------------------------------------
        Next i

        '結果を返す
        Return result * Me.sOrder

    End Function

End Class

<Serializable()> _
Public Class Settings
    Public srcPath As String
    Public dstPath As String

End Class

